unit Unit_rx_filtr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit_frame_main, Unit_frame_filtr_main, Unit_frame_filtr;

type
  TForm_RX_filtr = class(TForm)
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Button_filtr_new: TButton;
    Button_filtr_del: TButton;
    Button_filtr_down: TButton;
    Button_filtr_up: TButton;
    Frame_filtr_main1: TFrame_filtr_main;
    Label4: TLabel;
    procedure Button_filtr_upClick(Sender: TObject);
    procedure Button_filtr_downClick(Sender: TObject);
    procedure Button_filtr_delClick(Sender: TObject);
    procedure Button_filtr_newClick(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
    
    filtr_frames:array[1..100]of TFrame_filtr;

    filtr_framecount: integer;
    highlight_filtr_frame: integer;

    procedure frame_filtr_change(n:integer);

  end;

var
  Form_RX_filtr: TForm_RX_filtr;

implementation

{$R *.dfm}

procedure TForm_RX_filtr.Button_filtr_upClick(Sender: TObject);
var b:boolean;
    s:string;
begin
  if filtr_framecount<2 then exit;
  if highlight_filtr_frame<2 then exit;


  s:=filtr_frames[highlight_filtr_frame].Edit_filtr.text;
  filtr_frames[highlight_filtr_frame].Edit_filtr.text:=filtr_frames[highlight_filtr_frame-1].Edit_filtr.text;
  filtr_frames[highlight_filtr_frame-1].Edit_filtr.text:=s;

  s:=filtr_frames[highlight_filtr_frame].ComboBox_filtr_macro.text;
  filtr_frames[highlight_filtr_frame].ComboBox_filtr_macro.text:=filtr_frames[highlight_filtr_frame-1].ComboBox_filtr_macro.text;
  filtr_frames[highlight_filtr_frame-1].ComboBox_filtr_macro.text:=s;

  b:=filtr_frames[highlight_filtr_frame].CheckBox_filtr_active.Checked;
  filtr_frames[highlight_filtr_frame].CheckBox_filtr_active.Checked:=filtr_frames[highlight_filtr_frame-1].CheckBox_filtr_active.Checked;
  filtr_frames[highlight_filtr_frame-1].CheckBox_filtr_active.Checked:=b;

  b:=filtr_frames[highlight_filtr_frame].CheckBox_filtr_hex.Checked;
  filtr_frames[highlight_filtr_frame].CheckBox_filtr_hex.Checked:=filtr_frames[highlight_filtr_frame-1].CheckBox_filtr_hex.Checked;
  filtr_frames[highlight_filtr_frame-1].CheckBox_filtr_hex.Checked:=b;

  frame_filtr_change(highlight_filtr_frame-1);
end;

procedure TForm_RX_filtr.Button_filtr_downClick(Sender: TObject);
var b:boolean;
    s:string;
begin
  if filtr_framecount<2 then exit;
  if highlight_filtr_frame>(filtr_framecount-1) then exit;

  s:=filtr_frames[highlight_filtr_frame].Edit_filtr.text;
  filtr_frames[highlight_filtr_frame].Edit_filtr.text:=filtr_frames[highlight_filtr_frame+1].Edit_filtr.text;
  filtr_frames[highlight_filtr_frame+1].Edit_filtr.text:=s;

  s:=filtr_frames[highlight_filtr_frame].ComboBox_filtr_macro.text;
  filtr_frames[highlight_filtr_frame].ComboBox_filtr_macro.text:=filtr_frames[highlight_filtr_frame+1].ComboBox_filtr_macro.text;
  filtr_frames[highlight_filtr_frame+1].ComboBox_filtr_macro.text:=s;

  b:=filtr_frames[highlight_filtr_frame].CheckBox_filtr_active.Checked;
  filtr_frames[highlight_filtr_frame].CheckBox_filtr_active.Checked:=filtr_frames[highlight_filtr_frame+1].CheckBox_filtr_active.Checked;
  filtr_frames[highlight_filtr_frame+1].CheckBox_filtr_active.Checked:=b;

  b:=filtr_frames[highlight_filtr_frame].CheckBox_filtr_hex.Checked;
  filtr_frames[highlight_filtr_frame].CheckBox_filtr_hex.Checked:=filtr_frames[highlight_filtr_frame+1].CheckBox_filtr_hex.Checked;
  filtr_frames[highlight_filtr_frame+1].CheckBox_filtr_hex.Checked:=b;

  frame_filtr_change(highlight_filtr_frame+1);
end;

procedure TForm_RX_filtr.Button_filtr_delClick(Sender: TObject);
var n: integer;
begin
  if filtr_framecount<2 then exit;

  for n:=highlight_filtr_frame to filtr_framecount-1 do
    begin

//      filtr_frames[n].Edit_filtr.Tag:=filtr_frames[n+1].Edit_filtr.Tag;
      filtr_frames[n].Edit_filtr.text:=filtr_frames[n+1].Edit_filtr.text;
      filtr_frames[n].ComboBox_filtr_macro.text:=filtr_frames[n+1].ComboBox_filtr_macro.text;
      filtr_frames[n].CheckBox_filtr_active.Checked:=filtr_frames[n+1].CheckBox_filtr_active.Checked;
      filtr_frames[n].CheckBox_filtr_hex.Checked:=filtr_frames[n+1].CheckBox_filtr_hex.Checked;

    end;

  filtr_frames[filtr_framecount].Destroy;
  filtr_framecount:=filtr_framecount-1;
  if(highlight_filtr_frame>filtr_framecount) then frame_filtr_change(filtr_framecount);

  Constraints.MaxHeight:=23*filtr_framecount+100;
end;

procedure TForm_RX_filtr.Button_filtr_newClick(Sender: TObject);
begin
  filtr_framecount:=filtr_framecount+1;

//  Form_filtr.Frame_filtr_main1.height:=30*form_filtr.filtr_framecount;

  Constraints.MaxHeight:=23*filtr_framecount+100;

  if height<500 then height:=height+23;

  filtr_frames[filtr_framecount]:=TFrame_filtr.Create(Frame_filtr_main1);

  filtr_frames[filtr_framecount].Name:='filtr_frame_'+inttostr(filtr_framecount);
  filtr_frames[filtr_framecount].Edit_filtr.tag:=filtr_framecount;
  filtr_frames[filtr_framecount].Parent:=Frame_filtr_main1;

  filtr_frames[filtr_framecount].left:=0;
  filtr_frames[filtr_framecount].top:=filtr_framecount*23-23-Frame_filtr_main1.VertScrollBar.Position;
  filtr_frames[filtr_framecount].width:=Frame_filtr_main1.clientwidth;
  filtr_frames[filtr_framecount].height:=23;

  filtr_frames[filtr_framecount].Anchors:=[akLeft,akRight,akTop];

  filtr_frames[filtr_framecount].visible:=true;

  filtr_frames[filtr_framecount].Edit_filtr.Text:='';
  filtr_frames[filtr_framecount].ComboBox_filtr_macro.Text:='';
  filtr_frames[filtr_framecount].CheckBox_filtr_active.Checked:=False;
  filtr_frames[filtr_framecount].CheckBox_filtr_hex.Checked:=False;

end;


procedure TForm_RX_filtr.frame_filtr_change(n:integer);
var i:integer;
begin
  highlight_filtr_frame:=n;
  for i:=1 to filtr_framecount do
    if i=n then filtr_frames[i].color:=cl3DDkShadow
    else filtr_frames[i].color:=clBtnFace;

end;

end.
