unit Unit_tx;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit_frame_tx, Unit_frame_main;

type
  TForm_TX = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Button_new_tx: TButton;
    Label3: TLabel;
    Button_del_tx: TButton;
    Button_tx_up: TButton;
    Button_tx_down: TButton;
    Frame_TX_main1: TFrame_TX_main;
    Label4: TLabel;
    procedure Button_new_txClick(Sender: TObject);
    procedure Button_del_txClick(Sender: TObject);
    procedure Button_tx_downClick(Sender: TObject);
    procedure Button_tx_upClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }


    TX_frames:array[1..100]of TFrame_tx;

    TX_framecount: integer;
    highlight_TX_frame: integer;

     procedure frame_TX_change(n:integer);
  end;

var
  Form_TX: TForm_TX;

implementation

{$R *.dfm}

procedure TForm_TX.Button_new_txClick(Sender: TObject);
begin
  TX_framecount:=TX_framecount+1;

//  Form_TX.Frame_TX_main1.height:=30*form_TX.TX_framecount;

  Constraints.MaxHeight:=23*TX_framecount+100;

  if height<500 then height:=height+23;

  TX_frames[TX_framecount]:=TFrame_tx.Create(Frame_TX_main1);

  TX_frames[TX_framecount].Name:='tx_frame_'+inttostr(TX_framecount);
  TX_frames[TX_framecount].Edit_popis.tag:=TX_framecount;
  TX_frames[TX_framecount].Parent:=Frame_TX_main1;

  TX_frames[TX_framecount].left:=0;
  TX_frames[TX_framecount].top:=TX_framecount*23-23-Frame_TX_main1.VertScrollBar.Position;
  TX_frames[TX_framecount].width:=Frame_TX_main1.clientwidth;
  TX_frames[TX_framecount].height:=23;

  TX_frames[TX_framecount].Anchors:=[akLeft,akRight,akTop];

  TX_frames[TX_framecount].visible:=true;

  TX_frames[TX_framecount].Edit_popis.Text:='tx_'+inttostr(TX_framecount);
  TX_frames[TX_framecount].Edit_data.Text:='data_'+inttostr(TX_framecount);
  TX_frames[TX_framecount].Edit_interval.Text:=inttostr(1000);
  
end;

procedure TForm_TX.frame_TX_change(n:integer);
var i:integer;
begin
  highlight_TX_frame:=n;
  for i:=1 to TX_framecount do
    if i=n then TX_frames[i].color:=cl3DDkShadow
    else TX_frames[i].color:=clBtnFace;

end;

procedure TForm_TX.Button_del_txClick(Sender: TObject);
var n: integer;
begin
  if TX_framecount<2 then exit;

  for n:=highlight_TX_frame to TX_framecount-1 do
    begin
      TX_frames[n].Timer1.Enabled:=false;
//      TX_frames[n].Edit_popis.Tag:=TX_frames[n+1].Edit_popis.Tag;
      TX_frames[n].Edit_popis.text:=TX_frames[n+1].Edit_popis.text;
      TX_frames[n].Edit_data.text:=TX_frames[n+1].Edit_data.text;
      TX_frames[n].Edit_interval.text:=TX_frames[n+1].Edit_interval.text;
      TX_frames[n].CheckBox1.Checked:=TX_frames[n+1].CheckBox1.Checked;
      TX_frames[n].CheckBox_hex.Checked:=TX_frames[n+1].CheckBox_hex.Checked;
      TX_frames[n].Timer1.Enabled:=TX_frames[n+1].CheckBox1.Checked;
    end;

  TX_frames[TX_framecount].Destroy;
  TX_framecount:=TX_framecount-1;
  if(highlight_TX_frame>TX_framecount) then frame_TX_change(TX_framecount);

  Constraints.MaxHeight:=23*TX_framecount+100;
end;

procedure TForm_TX.Button_tx_downClick(Sender: TObject);
var b:boolean;
    s:string;
begin
  if TX_framecount<2 then exit;
  if highlight_TX_frame>(TX_framecount-1) then exit;

  TX_frames[highlight_TX_frame].Timer1.Enabled:=false;
  TX_frames[highlight_TX_frame+1].Timer1.Enabled:=false;

  s:=TX_frames[highlight_TX_frame].Edit_popis.text;
  TX_frames[highlight_TX_frame].Edit_popis.text:=TX_frames[highlight_TX_frame+1].Edit_popis.text;
  TX_frames[highlight_TX_frame+1].Edit_popis.text:=s;

  s:=TX_frames[highlight_TX_frame].Edit_data.text;
  TX_frames[highlight_TX_frame].Edit_data.text:=TX_frames[highlight_TX_frame+1].Edit_data.text;
  TX_frames[highlight_TX_frame+1].Edit_data.text:=s;

  s:=TX_frames[highlight_TX_frame].Edit_interval.text;
  TX_frames[highlight_TX_frame].Edit_interval.text:=TX_frames[highlight_TX_frame+1].Edit_interval.text;
  TX_frames[highlight_TX_frame+1].Edit_interval.text:=s;

  b:=TX_frames[highlight_TX_frame].CheckBox_hex.Checked;
  TX_frames[highlight_TX_frame].CheckBox_hex.Checked:=TX_frames[highlight_TX_frame+1].CheckBox_hex.Checked;
  TX_frames[highlight_TX_frame+1].CheckBox_hex.Checked:=b;

  b:=TX_frames[highlight_TX_frame].CheckBox1.Checked;
  TX_frames[highlight_TX_frame].CheckBox1.Checked:=TX_frames[highlight_TX_frame+1].CheckBox1.Checked;
  TX_frames[highlight_TX_frame+1].CheckBox1.Checked:=b;

  TX_frames[highlight_TX_frame].Timer1.Enabled:=TX_frames[highlight_TX_frame].CheckBox1.Checked;
  TX_frames[highlight_TX_frame+1].Timer1.Enabled:=TX_frames[highlight_TX_frame+1].CheckBox1.Checked;

  frame_TX_change(highlight_TX_frame+1);
end;

procedure TForm_TX.Button_tx_upClick(Sender: TObject);
var b:boolean;
    s:string;
begin
  if TX_framecount<2 then exit;
  if highlight_TX_frame<2 then exit;

  TX_frames[highlight_TX_frame].Timer1.Enabled:=false;
  TX_frames[highlight_TX_frame-1].Timer1.Enabled:=false;

  s:=TX_frames[highlight_TX_frame].Edit_popis.text;
  TX_frames[highlight_TX_frame].Edit_popis.text:=TX_frames[highlight_TX_frame-1].Edit_popis.text;
  TX_frames[highlight_TX_frame-1].Edit_popis.text:=s;

  s:=TX_frames[highlight_TX_frame].Edit_data.text;
  TX_frames[highlight_TX_frame].Edit_data.text:=TX_frames[highlight_TX_frame-1].Edit_data.text;
  TX_frames[highlight_TX_frame-1].Edit_data.text:=s;

  s:=TX_frames[highlight_TX_frame].Edit_interval.text;
  TX_frames[highlight_TX_frame].Edit_interval.text:=TX_frames[highlight_TX_frame-1].Edit_interval.text;
  TX_frames[highlight_TX_frame-1].Edit_interval.text:=s;

  b:=TX_frames[highlight_TX_frame].CheckBox_hex.Checked;
  TX_frames[highlight_TX_frame].CheckBox_hex.Checked:=TX_frames[highlight_TX_frame-1].CheckBox_hex.Checked;
  TX_frames[highlight_TX_frame-1].CheckBox_hex.Checked:=b;

  b:=TX_frames[highlight_TX_frame].CheckBox1.Checked;
  TX_frames[highlight_TX_frame].CheckBox1.Checked:=TX_frames[highlight_TX_frame-1].CheckBox1.Checked;
  TX_frames[highlight_TX_frame-1].CheckBox1.Checked:=b;

  TX_frames[highlight_TX_frame].Timer1.Enabled:=TX_frames[highlight_TX_frame].CheckBox1.Checked;
  TX_frames[highlight_TX_frame-1].Timer1.Enabled:=TX_frames[highlight_TX_frame-1].CheckBox1.Checked;

  frame_TX_change(highlight_TX_frame-1);
end;

end.
