unit Unit_frame_tx;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ExtCtrls;

type
  TFrame_tx = class(TFrame)
    Edit_data: TEdit;
    Edit_interval: TEdit;
    Timer1: TTimer;
    Button_send: TButton;
    CheckBox1: TCheckBox;
    Edit_popis: TEdit;
    CheckBox_hex: TCheckBox;
    procedure Button_sendClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Enter(Sender: TObject);
    procedure FrameClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses Unit1, Unit_tx, IdSocketHandle, Unit_rx_TX, Unit_TXW;

{$R *.dfm}

procedure TFrame_tx.Button_sendClick(Sender: TObject);
var t, a, s, st, h :string;
    i: integer;
begin

      if CheckBox_hex.Checked then
        s:=form1.hextostr(Edit_data.text)
      else
        s:=form1.wildtostr(Edit_data.text);

      st:='';
      for i:=1 to length(s) do
        if ord(s[i])>31 then st:=st+s[i]
        else st:=st+'<'+ascii_names[ord(s[i])].name+'>';


      h:='';
      if Form_RX_TX.CheckBox_hex.Checked then
        begin
          for i:=1 to length(s) do
            h:=h+' '+inttohex(ord(s[i]),2);
        end;

      if Form_RX_TX.CheckBox_time.Checked then
        t:=timetostr(now)+' '
      else
        t:='';


        if form1.ApdComPort1.Open then    // COM
          begin
            if Form_RX_TX.CheckBox_adr.Checked then
              a:='na: COM'+inttostr(form1.ApdComPort1.ComNumber)+' '
            else
              a:='';
          end

        else if form1.IdTCPServer1.Bindings.count>0 then   // TCP  server
          begin
            if Form_RX_TX.CheckBox_adr.Checked then
              a:='na: localhost : '+form1.Edit_TCP_S_port.Text+' '
            else
              a:='';
//              st:=inttostr(form1.IdTCPServer1.Bindings[0].)+' '+form1.IdTCPServer1.Bindings[0].DisplayName;
          end

        else if form1.IdTCPClient1.Connected then    // TCP client
          begin
            if Form_RX_TX.CheckBox_adr.Checked then
              a:='na: '+form1.Edit_tcp_k_addr.text+' : '+form1.Edit_tcp_k_port.Text+' '
            else
              a:='';
          end

        else if form1.IdUDPServer1.Active then       // UDP
          begin
            if Form_RX_TX.CheckBox_adr.Checked then
              a:='na: '+form1.Edit_tx_adr.text+' : '+form1.Edit_tx_port.Text+' '
            else
              a:='';
          end

        else if form1.ICMP_connected then       // ICMP
          begin
            if Form_RX_TX.CheckBox_adr.Checked then
              a:='na: '+form1.Edit_icmp_a.text+' '
            else
              a:='';
          end

        else
          begin
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clblack;
            form_rx_TX.RichEdit_mix.Lines.Add('CHYBA: dn aktivn pipojen');
            exit;
          end;

        if Form_RX_TX.CheckBox_tx.Checked then
          begin
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clBlack;
            form_rx_TX.RichEdit_mix.SelAttributes.name:='MS Sans Serif';
            form_rx_TX.RichEdit_mix.Lines.Add(t+'Odeslal data '+a+':');
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clBlue;
            form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
            form_rx_TX.RichEdit_mix.Lines.Add('  '+st);
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clBlue;
            form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
            if Form_RX_TX.CheckBox_hex.Checked then
              form_rx_TX.RichEdit_mix.Lines.Add(' '+h);
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clBlue;
            form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
            Form_RX_TX.label_lines.Caption:=inttostr(form_rx_TX.RichEdit_mix.lines.Count);
          end;

        // okno form_txw
        if form_txw.RichEdit_tx.Lines.Count=0 then form_txw.RichEdit_tx.Lines.add('');
        case form_txw.ComboBox_format.ItemIndex of
          0: begin  // formatovat
            i:=1;
            while i<=length(s) do
              begin
                if s[i]>=' ' then
                  form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]:=
                    form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]+(s[i])
                else if (s[i]=#$0d)or((s[i]=#$0a)and
                          (form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]<>''))  then
                   form_txw.RichEdit_tx.Lines.add('');
                i:=i+1;
              end;

          end;
          1: begin  // neviditelne
            form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]:=
              form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]+(st);
          end;
          2: begin  // neviditelne podle bloku
            form_txw.RichEdit_tx.Lines.add(st);
          end;
          3: begin  // sestnactkove
            form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]:=
              form_txw.RichEdit_tx.Lines[form_txw.RichEdit_tx.Lines.Count-1]+(h);
          end;
          4: begin  // sestnactkove podle bloku
            form_txw.RichEdit_tx.Lines.add(h);
          end;
        end;
      try

        if form1.ApdComPort1.Open then    // COM
          begin
            form1.ApdComPort1.PutString(s);
          end

        else if form1.IdTCPServer1.Bindings.count>0 then   // TCP  server
          begin
              form1.idtcp_thread.connection.Write(s);
 //           form1.IdTCPServer1.Bindings[0].Port
 //           send(s,2,1);
          end

        else if form1.IdTCPClient1.Connected then    // TCP client
          begin
            form1.IdTCPClient1.Write(s)
          end

        else if form1.IdUDPServer1.Active then       // UDP
          begin
            form1.IdUDPServer1.Send(form1.Edit_tx_adr.Text, strtoint(form1.Edit_tx_port.text), s)
          end

        else if form1.ICMP_connected then       // ICMP
          begin
            form1.IdIcmpClient1.Host:=form1.Edit_icmp_a.text;
 //           form1.IdIcmpClient1.port:=strtoint(form1.Edit_icmp_p.Text);
            form1.IdIcmpClient1.Ping(s,0);
          end

        else
          begin
            form_rx_TX.RichEdit_mix.SelAttributes.Color:=clblack;
            form_rx_TX.RichEdit_mix.Lines.Add('CHYBA: dn aktivn pipojen');
            exit;
          end;

      except
        form_rx_TX.RichEdit_mix.SelAttributes.Color:=clblack;
        form_rx_TX.RichEdit_mix.SelAttributes.name:='MS Sans Serif';
        form_rx_TX.RichEdit_mix.Lines.Add('CHYBA: Nepovedlo se odeslat.');
      end;



end;


procedure TFrame_tx.CheckBox1Click(Sender: TObject);
begin
  timer1.Interval:=strtoint(Edit_interval.text);
  timer1.Enabled:=CheckBox1.Checked;
  Edit_interval.Enabled:=not CheckBox1.Checked;
end;

procedure TFrame_tx.Timer1Timer(Sender: TObject);
begin
  Button_sendClick(sender);
end;

procedure TFrame_tx.CheckBox1Enter(Sender: TObject);
begin
  form_tx.frame_TX_change(Edit_popis.tag);
end;

procedure TFrame_tx.FrameClick(Sender: TObject);
begin
  form_tx.frame_TX_change(Edit_popis.tag);
end;

end.
